import Fuse from 'fuse.js';
import * as React from 'react';
declare class FuzzyHighlighter<T, O> extends React.Component<IFuzzyHighlighterProps<T, O>, IFuzzyHighlighterState<T>> {
    readonly state: IFuzzyHighlighterState<T>;
    private fuse;
    componentDidMount(): void;
    componentDidUpdate(prevProps: IFuzzyHighlighterProps<T, O>): void;
    render(): {} | null | undefined;
    search(): void;
}
declare type Data<T> = ReadonlyArray<T>;
declare type Options<O> = Fuse.FuseOptions<Readonly<O>>;
interface IFuzzyHighlighterProps<T, O> {
    query: string;
    data: Data<T>;
    options?: Options<O>;
    children?: (params: {
        results: Data<T>;
        timing: number;
    }) => React.ReactNode;
}
interface IFuzzyHighlighterState<T> {
    results: Data<T>;
    cache: {
        [query: string]: Data<T>;
    };
    info: {
        timing: number;
    };
}
export default FuzzyHighlighter;
